<?php
/* $Id: view.inc.php,v 1.3 2001/09/29 23:19:58 dandra Exp $php_extension.",v 1.1 2000/12/07 12:51:27 dandra Exp $ */
/* $Id: view.inc.php,v 1.3 2001/09/29 23:19:58 dandra Exp $php_extension.",v 1.1 2000/12/07 12:51:27 dandra Exp $ */
// Get a banner
function get_banner($what, $clientID, $context=0)
{
    global $phpAds_db, $REMOTE_HOST, $phpAds_tbl_banners, $REMOTE_ADDR, $HTTP_USER_AGENT; 
    $where = "";
    if($context == 0)
    {
        $context = array();
    }
    
    for($i=0; $i<count($context); $i++)
    {
        list($key, $value) = each($context[$i]);
        {
            switch($key)
            {
                case "!=": $exclusive[] = "bannerID <> $value"; break;
                case "==": $inclusive[] = "bannerID = $value"; break;
            }
        }
    }
    
    $where_exclusive = !empty($exclusive) ? implode(" AND ", $exclusive): "";
    $where_inclusive = !empty($inclusive) ? implode(" OR ", $inclusive): "";
    
    $where = sprintf("$where_inclusive %s $where_exclusive", (!empty($where_inclusive) && !empty($where_exclusive)) ? "AND": "");
        
    $where = trim($where);
    if(!empty($where))
    {
        $where .= " AND ";
    }        
        
    $select = "SELECT 
                  bannerID,
                  banner,
                  format,
                  width,
                  height,
                  alt,
                  bannertext,
                  url
              FROM
                  $phpAds_tbl_banners 
              WHERE
                  $where
                  active = 'true' ";
                  
    if($clientID != 0)
    {
        $select .= " AND clientID =".$clientID." ";
    }                  
    
    if((is_string($what)) && (!ereg("[0-9]x[0-9]", $what)))
    {
        switch($what) 
        {
            // Get all HTML banners     
            case "html":  
                    $select .= " AND format = 'html' ";
                    break;
            //Not any of the special words (i.e. 'html'), So, must be a keyword
            default: 
                $select .= " AND (";
                
                $what_array = explode(",",$what);
                
                for($k=0; $k<count($what_array); $k++)
                {
                    $select .= "keyword = '".trim($what_array[$k])."' OR ";
                }
                /*
                The special 'global' keyword allows you to define a banner as global and
                show up under all keywords. I put this in so that if I didn't have any banners 
                for a particular keyword, instead of being blank, it would show one of the global
                banners - Weston Bustraan <weston@infinityteldata.net> 
                */                
                $select .= "keyword = 'global') ";
        } //switch($what)
    } 
    else if(is_int($what))
    {
        $select .= " AND bannerID=".$what." ";
    }
    else
    {
        list($width, $height) = explode("x", $what);
        // Get all banners with the specified width/height
        $select .= " AND width=".$width." AND height=".$height." ";
    }
    
    // print($select);
    $res = @mysql_db_query($phpAds_db, $select);
    if(!$res)
        return(false);
    $rows = array();
    while ($tmprow = @mysql_fetch_array($res)) 
	{
	   	$rows[] = $tmprow; 
    }
    $date = getdate(time());
    $request = array('remote_host'	=> 	$REMOTE_ADDR,
		     'user_agent'	=>	$HTTP_USER_AGENT,
		     'weekday'		=>	$date['wday']);
    srand((double)microtime()*1000000);
	// echo rand()."-";
	// Shuffle is broken
    // shuffle($rows);
	if (count($rows) > 1)
	{
		$rownum = rand(0, count($rows) -1);
	}
	else
	{
		$rownum = 0;
	}
	$row = $rows[$rownum];
	// echo count($rows)."-";
	/*
    for ($i = 1; $i < count($rows); $i++) 
	{
    	if (acl_check($request, $rows[$i])) 
		{
	    	$row = $rows[$i];
			// Test
			// echo $row[bannerID];
		    break;
		}
    }
	*/
    	if (acl_check($request, $rows[$rownum])) 
		{
	    	$row = $rows[$rownum];
			// Test
			// echo $row[bannerID];
		    // break;
		}
    return($row);
}
// Log an adview for the banner with $bannerID
function log_adview($bannerID)
{
    global $phpAds_log_adviews, $phpAds_ignore_hosts, $phpAds_reverse_lookup, $phpAds_insert_delayed;
    global $row, $phpAds_tbl_adviews;
    global $REMOTE_HOST, $REMOTE_ADDR, $host;
    if(!$phpAds_log_adviews)
    {
        return(false);
    }

  if($phpAds_reverse_lookup)
  {
  	if ($host == "")
	{
		$host = isset($REMOTE_HOST) ? $REMOTE_HOST : @gethostbyaddr($REMOTE_ADDR);
	}
  }
  else
  {
  	if ($host == "")
	{
		$host = $REMOTE_ADDR;
	}
  }
    // Check if host is on list of hosts to ignore
    $found = 0;
    while(($found == 0) && (list($key, $ignore_host)=each($phpAds_ignore_hosts))) 
    {
        if(eregi($ignore_host, $host)) // host found in ignore list
        {
            $found = 1;
        }
    }
    if($found == 0)
    { 
        $res = @mysql_db_query($GLOBALS["phpAds_db"], sprintf("
          INSERT %s
          
            INTO $phpAds_tbl_adviews
          VALUES
            (
            '$bannerID',
            null,
            '$host'
            )
            ", $phpAds_insert_delayed ? "DELAYED": "")); 
    }
}
// view a banner 
function view($what, $clientID=0, $target = "", $withtext=0, $context=0)
{
    global $phpAds_db, $REMOTE_HOST, $host;
    if(!is_int($clientID))
    {
        $target = $clientID;
        $clientID = 0;
    }
    @mysql_pconnect($GLOBALS["phpAds_hostname"], $GLOBALS["phpAds_mysqluser"], $GLOBALS["phpAds_mysqlpassword"]);
    $row = get_banner($what, $clientID, $context);
    if(!empty($row["bannerID"])) 
    {
        if(!empty($target))
        {
			$target_var = $target;
            $target = " target=\"$target\"";
        }
		else
		{
			$target_var = "_top";
		}
        if($row["format"] == "html")
        {
			// echo '<iframe src="'.$GLOBALS[phpAds_url_prefix].'/viewiframe'.$php_extension.'?bannerID='.$row[bannerID].'&target='.$target_var.'" width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
			// echo '<a href="'.$GLOBALS[phpAds_url_prefix].'/click'.$php_extension.'?bannerID='.$row[bannerID].'"'.$target.'>';
			echo $row["banner"];
			// echo '</a>';
			// echo '</iframe>';
			/*
            if(!empty($row["url"])) 
            {
                // echo "<a href=\"$GLOBALS[phpAds_url_prefix]/click'.$php_extension.'?bannerID=$row[bannerID]\"$target>";
                // echo '<ilayer src="'.$GLOBALS[phpAds_url_prefix].'/viewiframe'.$php_extension.'?bannerID='.$row[bannerID].'&target='.$target_var.'" width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
                echo '<iframe src="'.$GLOBALS[phpAds_url_prefix].'/viewiframe'.$php_extension.'?bannerID='.$row[bannerID].'&target='.$target_var.'" width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
                echo '<a href="'.$GLOBALS[phpAds_url_prefix].'/click'.$php_extension.'?bannerID='.$row[bannerID].'"'.$target.'>';
            }
            echo $row["banner"];
            if(!empty($row["url"])) 
            {
                echo '</a>';
				echo '</iframe>';
				// echo '</ilayer>';
            }
			*/
			if($withtext && !empty($row["bannertext"]) && !empty($row["url"]))
			{
				echo "<BR>\n<a href=\"$GLOBALS[phpAds_url_prefix]/click".$php_extension."?bannerID=$row[bannerID]\"$target>".$row["bannertext"]."</a>";
			}
			else if($withtext && !empty($row["bannertext"]) && empty($row["url"]))
			{
				echo "<BR>\n".$row["bannertext"];
			}
		}
        else if($row["format"] == "swf")
        {
			// ILayer like Netscape 4.x
			/*
			echo '<ilayer src="';
			echo $GLOBALS[phpAds_url_prefix].'/viewiframe'.$php_extension.'?bannerID='.$row[bannerID].'&target='.$target_var;
			echo '" width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
			*/
			// IFrame like HTML 4.0
			echo '<iframe src="';
			echo $GLOBALS[phpAds_url_prefix].'/viewiframe'.$php_extension.'?bannerID='.$row[bannerID].'&target='.$target_var.'"';
			echo ' width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
			// Plain like all others
            echo '<a href="'.$GLOBALS[phpAds_url_prefix].'/click'.$php_extension.'?bannerID='.$row[bannerID].'"'.$target.'>';
			echo '<object classid="" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=4,0,2,0" width="'.$row[width].'" height="'.$row[height].'">';
			echo '<param name=movie value="'.$GLOBALS[phpAds_url_prefix].'/viewbanner'.$php_extension.'?bannerID='.$row[bannerID].'">';
            echo '<param name=quality value=high><param name="LOOP" value="false"><param name="menu" value="false"><param name="wmode" value="opaque">';
			echo '<embed src="'.$GLOBALS[phpAds_url_prefix].'/viewbanner'.$php_extension.'?bannerID='.$row[bannerID].'&ext=.swf" quality=high pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash" type="application/x-shockwave-flash" width="'.$row[width].'" height="'.$row[height].'" loop="false" menu="false" wmode="opaque"></embed>';
			echo '</object>';
		  // echo '<embed src="'.$GLOBALS[phpAds_url_prefix].'/viewbanner'.$php_extension.'?bannerID='.$row[bannerID].'.swf" width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" border="0">';
			echo '</a>';
			echo '</iframe>';
			// echo '</ilayer>';
    
            if($withtext && !empty($row["bannertext"]))
            {
                echo "<BR>\n<a href=\"$GLOBALS[phpAds_url_prefix]/click".$php_extension."?bannerID=$row[bannerID]\"$target>".$row["bannertext"]."</a>";
            }        
        }
        else
        {
			// ILayer like Netscape 4.x
			/*
			echo '<ilayer src="';
			echo $GLOBALS[phpAds_url_prefix].'/viewiframe'.$php_extension.'?bannerID='.$row[bannerID].'&target='.$target_var.'"';
			echo ' width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
			*/
			// IFrame like HTML 4.0
			echo '<iframe src="';
			echo $GLOBALS[phpAds_url_prefix].'/viewiframe'.$php_extension.'?bannerID='.$row[bannerID].'&target='.$target_var;
			echo '" width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no">';
			// Plain for all others
            echo '<a href="'.$GLOBALS[phpAds_url_prefix].'/click'.$php_extension.'?bannerID='.$row[bannerID].'"'.$target.'><img src="'.$GLOBALS[phpAds_url_prefix].'/viewbanner'.$php_extension.'?bannerID='.$row[bannerID].'" width="'.$row[width].'" height="'.$row[height].'" alt="'.$row[alt].'" border="0"></a>';
			echo '</iframe>';
			// echo '</ilayer>';
    
            if($withtext && !empty($row["bannertext"]))
            {
                echo "<BR>\n<a href=\"$GLOBALS[phpAds_url_prefix]/click".$php_extension."?bannerID=$row[bannerID]\"$target>".$row["bannertext"]."</a>";
            }        
        }
    }
    log_adview($row["bannerID"]);
    return($row["bannerID"]);
}
function view_t($what, $target = "")
{
    view ($what, $target, 1);
}
?>
